;;; -*- Mode: Lisp; Syntax: ANSI-Common-Lisp; Base: 10; -*-
;;;
;;; example.lisp --- Sample code showing use of cl-opossum.

;; Copyright (C) 2008 Utz-Uwe Haus <lisp@uuhaus.de>
;; $Id$
;; This code is free software; you can redistribute it and/or modify
;; it under the terms of the version 3 of the GNU General
;; Public License as published by the Free Software Foundation, as
;; clarified by the prequel found in LICENSE.Lisp-GPL-Preface.
;;
;; This code is distributed in the hope that it will be useful, but
;; without any warranty; without even the implied warranty of
;; merchantability or fitness for a particular purpose. See the GNU
;; Lesser General Public License for more details.
;;
;; Version 3 of the GNU General Public License is in the file
;; LICENSE.GPL that was distributed with this file. If it is not
;; present, you can access it from
;; http://www.gnu.org/copyleft/gpl.txt (until superseded by a
;; newer version) or write to the Free Software Foundation, Inc., 59
;; Temple Place, Suite 330, Boston, MA 02111-1307 USA
;;
;; Commentary:

;; Load this file into your lisp to see how cl-opossum can be utilized
;; in your own programs.

;;; Code:



(in-package #:CL-USER)

;; load the opossum package
(asdf:operate 'asdf:load-op :opossum)
;; => NIL

;; Create a parser for the grammar defined in example.peg, in a fresh package
(setq *p* (opossum:make-string-parser "example.peg"))
;; => ...

;; use the parser to parse a string
(setq *t* (funcall *p* "14+7*(1+1)*2"))
;; => ...

;; and try out the code generated by the grammar
(eval *t*)
;; => 42
